(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
   Cette utilitaire permet de dcouper un fichier en plusieurs fichiers de  
 taille infrieure. Pour copier un fichier de 10 Mo sur une disquette par   
 exemple.                                                                   
Ĵ
  Version    Consultez le fichier 'UNITE\A-Lire.txt' pour comprendre      
    les caractres dbutant les lignes.                          
                                                                            
 06/10/1999 -> Version 0.0 (cration)                                       
 07/10/1999 -> Version 0.1 (Fonction principale installe : dcoupe d'un    
    fichier en plusieurs tranches)                                          
 08/10/1999 -> Version 0.2.0                                                
    * Modification du format de fichier CRC : v0.1                          
      - Nom du programme  installer                                        
      - Rpertoire source                                                   
      - Rpertoire destination                                              
 13/10/1999 -> Version 0.2.1                                                
    * Modification du format de fichier CRC : v0.2                          
      - Version sur deux caractres ('02' signifie version 0.2)             
 16/10/1999 -> Version 0.3.0                                                
    + Prsentation toujours plus belle et convivale                         
    + Vrification du nombre de tranche, plus de 20 demande confirmation    
    * Modification du fichier CRC : v0.3 -> Rorganisation interne          
 27/10/1999 -> Version 0.4.0                                                
    + Possibilit de laisser quelques Ko libre sur la disquette n1         
 18/11/1999 -> Version 0.5.0                                                
    * Modification du fichier CRC : v0.4 -> Texte d'installation port  62 
      caractres et = 'Installation ' + texte, au lieu de 'Installation de '
      + texte                                                               
    * Copie directe des fichiers sur une disquette (tranche + script +      
      'install.exe' sur la 1ere disquette )                                 
 21/11/1999 -> Version 0.5.1                                                
    * Modification du fichier CRC : v0.5 -> Suppresion du rpertoire        
      destination car :                                                     
    - Ne demande plus le rpertoire destination, le demande lors de         
      l'installation                                                        
Ĵ
  Facults futures                                                        
                                                        
                                                                            
 Attention "future" signifit "en cours de dveloppement" mais ce dvelop-   
 pement peut tre trs long ou ne jamais aboutir. Si vous pouvez m'aider   
 ajouter ces facults, envoyez moi un email : haypo@ifrance.com.            
                                                                            
 * Vrification du fichier par CRC                                          
 * Support des noms de fichier longs                                        
*)

{$A+: Utilise des adresses paire (plus rapide)                               }
{$B+: Optimise les valuations logiques                                      }
{$D-: N'insre pas d'informations pour le dboggage                          }
{$G+: Utilise les instructions du 286 (SHL/SHR/ENTER/LEAVE)                  }
{$I-: Ne teste pas les erreurs d'entre/sortie                               }
{$N-: N'utilise pas le co-processeur arithmtique                            }
{$Q-: Ne teste pas les erreurs de dbordement (Word(65535+1) par exemple)    }
{$R-: Ne teste pas les erreurs de domaine (Tableau, ex: EcrnTxt[4050])       }
{$S-: Ne teste pas le dbordement de la pile (8192 octets suffisent)         }
{$X+: Ne demande pas de variable pour stocker le rsultat d'une fonction     }

{$M 4096,0,65535}

uses
  Clavier,    { Interface utilisateur                                        }
  Dos,        { Gestion des fonctions DOS (DiskFree)                         }
  EcranTxt,   { Ecrit du texte en couleur                                    }
  GestFich,   { Gestion de fichiers : Ouverture, cration, taille, erreur,...}
  GestStrg,   { Gestion des chaines de caractres                            }
  StopProg;   { Stoppe le programme avec un message d'erreur standardis     }

const
  Version = '0.5.1';
  Email   = 'haypo@ifrance.com';
  PageWeb = 'http://www.haypo.fr.st/';

type
  FichierCRC = record { Script d'installation (Installation vierge)          }
    Signature   : Array[0..2] of char;  { = 'HYP'                            }
    Version     : Array[0..1] of char;  { XY signifie version X.Y            }
    NomFich     : String[12];           { abcdefgh.ijk                       }
    NomInstall  : String[62];           { Nom de l'installation              }
    TailleTotal : LongInt;              { Taille du fichier complet          }
    NbrFichier  : Word;                 { Nombre de tranche de fichier       }
  end;

  UnTampon = array[0..1] of byte;

const
  { Nom des fichiers }
  NomFichCRC   = 'install.crc';        { Script d'installation               }
  NomFichInstall = 'install.exe';      { Programme d'installation            }

  { Script d'installation }
  SignatureCRC = 'HYP';
  VersionCRC   = '05';
  TailleFichCRC = SizeOf(FichierCRC);

  { Autre }
  TailleTamponMin = 2048;       { Taille minimale du tampon : 2048 octets    }
  TailleDisquette = 1457664;    { Taille d'une disquette de 1.44 Mo          }
  TailleOccupeMax = 50000;      { Taille occup maximale d'une disquette     }
  TailleMinDisq1  = 100200;     { Taille libre minimum de la 1ere disquette  }
  TailleMinDisq   = 1000200;    { Taille libre minimum d'une disquette = 1Mo }
  LongTxtEstimation = 13;       { Longueur du texte d'estimation de la dure }
                                { de la copie                                }
var
  { Le fichier }
  F,FichSrc,FichDst: File;
  NomFich,NomFichTranche: String;
  SauveRep: String;
  TailleSuppl,
  TailleFich,TailleTotalFich,
  TailleTranche,TailleTmp,
  TailleRestTotal,TailleEcritRest: LongInt;

  { Barre d'avancement }
  BarreAvancement : record
    Avance : Byte;                     { Son avance (en caractre)           }
    Larg   : Byte;                     { Sa largeur (en caractre)           }
    Y      : Byte;                     { Sa position Y                       }
    PourcX : Byte;                     { Position X du texte affichant le    }
                                       { pourcentage d'avancement            }
    BarreX : Byte;                     { Position X de la barre d'avancement }
    TempsX : Byte;                     { Position X de l'estimation du temps }
  end;

  { Tampon mmoire pour la copie }
  Tampon: ^UnTampon;                   { Pointeur sur l'espace mmoire allou}
  TailleTampon: Word;                  { Taille de cet espace                }

  { Chonomtre }
  Chrono : LongInt absolute $0040: $006C;   { Chronomtre systme            }
  SauveChrono: LongInt;                { Sauvegarde de celui-ci pour pouvoir }
                                       { calculer une dure en click (1/18s) }

  { Estimation du temps restant de copie }
  Vitesse : record
    OctetLect,OctetEcrt,               { Total des octets lus/crits         }
    DureeLect,DureeEcrt: LongInt;      { Dure de la lecture/criture de ces }
                                       { octets                              }
    X,Y : Byte;                        { Position du texte                   }
  end;

  { Grandes variables }
  FichCRC: FichierCRC;

  { Ecran }
  TxtErreurY: Byte;                    { Position Y du texte d'erreur        }
  Vram      : Word;                    { Offset de la VRAM                   }

  { Reste : des variables }
  TmpL: LongInt;
  txt,TmpTxt: String;
  erreur: Integer;
  i,x,y: byte;
  ch: char;

procedure PrepareFin; far; begin
  { Retourne dans le rpetoire du dbut }
  if SauveRep<>'' then ChDir (SauveRep);

  { Rend le mmoire allou }
  if Tampon<>NIL then FreeMem (Tampon, TailleTampon);

  CurseurOn;
end;

procedure Fin (EffaceEcran: Boolean); begin
  PrepareFin;

  { Affiche le message d'adieu }
  if EffaceEcran then EffaceEcranTxt else EcriTr ('');
  EcriTc ('Decoupe',15+1*16); EcriTc (' v',7+1*16); EcriTcr (Version,14+1*16);
  EcriT ('Crateur: '); EcriTcr ('Haypo ',10);
  EcriT ('Email   : '); EcriTcr (Email,10);
  EcriT ('Sources : '); EcriTcr (PageWeb,10);
  SauteLigne;
  Halt;
end;

function CopieFichier (NomFich: String; NomFichDst: String; EffaceDoffice: Boolean) : Boolean; begin
  CopieFichier := FALSE;

  { Ouvre le fichier source }
  TestErreurFich (OuvreFichier (FichSrc,2,NomFich,''),NomFich,'ouverture du source  copier');

  { Le fichier exite dj ? }
  if FichierExistant(NomFichDst) and (not EffaceDoffice) then begin
    X := EcranX; Y := EcranY;
    EcriTcr ('Fichier dj existant !',12);
    EcriTc ('Voulez-vous le remplacer (O/N) ? ',15);
    ch := UpCase(LitTouche);
    PosX (0); EcriTh (80,' ');
    if ch<>'O' then begin
      PosY (EcranY-1);
      Exit;
    end else PosXY (X,Y);
  end;

  { Cre (ou remplace) le fichier destination }
  TestErreurFich (CreeFichier (FichDst,NomFichDst),NomFichDst,'cration du fichier destination');

  if FileSize(FichSrc)=0 then begin
    EcriTc ('Fichier de taille nulle !',12);
    Close (FichSrc);
    Close (FichDst);
  end;

  { Prpare la seconde barre d'avancement }
  with BarreAvancement do begin
    Y := EcranY;
    EcriTc ('000',9); PourcX := EcranX; Ecrit('% '); BarreX := EcranX;
    Larg := 80-EcranX-LongTxtEstimation; EcriTh (Larg,'');

    Ecrit (' '); Vitesse.X := EcranX; Vitesse.Y := EcranY;

    EcriTc ('estimation',15); EcriTh (80-EcranX,' ');
  end;

  TxtErreurY := EcranY +1;

  { Initialise l'estimation de temps }
  with Vitesse do begin
    OctetLect := 0; OctetEcrt := 0;
    DureeLect := 0; DureeEcrt := 0;
  end;

  { Copie le contenu du fichier source dans le fichier destination }
  TailleTmp := TailleTampon;
  repeat
    if FileSize(FichSrc)-FilePos(FichSrc)<TailleTmp then
      TailleTmp := FileSize(FichSrc)-FilePos(FichSrc);

    { Actualise la barre d'avancement }
    with BarreAvancement do with FichCRC do begin
      EcriTxhc (BarreX,Y,FilePos(FichSrc)*Larg div FileSize(FichSrc),'',10);
      Str (FilePos(FichSrc)*100 div FileSize(FichSrc),TmpTxt);
      EcriTxc (PourcX-length(TmpTxt),Y,TmpTxt,14);
    end;

    { Lecture d'un bloc et calcul de la vitesse de lecture }
    SauveChrono := Chrono;
    {$I-} BlockRead (FichSrc,Tampon^, TailleTmp); {$I+}
    if IOResult<>0 then begin
      PosXY (0,TxtErreurY);
      Vram := EcranY shl 7 +EcranY shl 5 +EcranX shl 1;
      Move (EcrnTxt[Vram],Tampon^,160);
      EcriTcr ('Erreur de lecture. Enfoncez une touche pour ressayer ou echape pour quitter.',14+6*16);
      TmpTxt := '- Nouvel essaie - ';
      repeat
        if UpCase (LitTouche)=_ECHAPE then Fin (TRUE);
        EcriTc (TmpTxt,13);
        {$I-} BlockRead (FichSrc,Tampon^, TailleTmp); {$I+}
        PosX (EcranX-length(TmpTxt));
        EcriTh (Length(TmpTxt),' ');
        PosX (EcranX-length(TmpTxt));
      until IOResult=0;
      Move (Tampon^,EcrnTxt[Vram],160);
    end else with Vitesse do begin
      inc (DureeLect, Chrono-SauveChrono );
      inc (OctetLect, TailleTmp);
    end;

    { Ecrit la partie du fichier }
    SauveChrono := Chrono;
    {$I-} BlockWrite (FichDst, Tampon^, TailleTmp); {$I+}
    if IOResult<>0 then begin
      PosXY (0,TxtErreurY);
      Vram := EcranY shl 7 +EcranY shl 5 +EcranX shl 1;
      Move (EcrnTxt[Vram],Tampon^,160);
      EcriTcr ('Erreur d''criture. Enfoncez une touche pour ressayer ou echape pour quitter.',14+6*16);
      TmpTxt := '- Nouvel essaie - ';
      repeat
        if UpCase (LitTouche)=_ECHAPE then Fin (TRUE);
        EcriTc (TmpTxt,13);
        {$I-} BlockWrite (FichDst, Tampon^, TailleTmp); {$I+}
        PosX (EcranX-length(TmpTxt));
        EcriTh (Length(TmpTxt),' ');
        PosX (EcranX-length(TmpTxt));
      until IOResult=0;
      Move (Tampon^,EcrnTxt[Vram],160);
    end else with Vitesse do begin
      inc (DureeEcrt, Chrono-SauveChrono );
      inc (OctetEcrt, TailleTmp);
    end;

    with Vitesse do begin
      { Calcule le temps restant de l'installation }
      PosXY (X,Y);
      if DureeLect<>0 then TmpL := (FileSize(FichSrc)-FilePos(FichSrc)) div (19*OctetLect div DureeLect) else TmpL := 0;
      if DureeEcrt<>0 then inc(TmpL, (FileSize(FichSrc)-FilePos(FichSrc)) div (19*OctetEcrt div DureeEcrt));

      { Ecrit la dure au format horaire (h:m:s, m:s ou s) }
      if 0<TmpL then begin
        if 3600<TmpL then begin
          Str (TmpL div 3600,txt);
          TmpL := TmpL mod 3600;

          Str (TmpL div 60,TmpTxt);
          TmpL := TmpL mod 60;
          txt := txt+'h '+TmpTxt+'min';

          Str (TmpL,TmpTxt);
          txt := txt+'s';
        end else begin
          if 60<TmpL then begin
            Str (TmpL div 60,txt);
            Str (TmpL mod 60,TmpTxt);
            txt := txt+'min '+TmpTxt+'s';
          end else begin
            Str (TmpL,txt);
            txt := txt+' seconde';
            if 1<TmpL then txt := txt+'s';
          end;
        end;
      end else txt := '< 1 seconde';
      EcriTc (txt,15); if EcranX<80 then EcriTh (80-EcranX,' ');
    end;

    { Une touche a t presse ? Est-ce la touche chape ? }
    if TouchPresse then begin
      LitTouche;

      PosXY (0,TxtErreurY);
      Vram := EcranY shl 7 +EcranY shl 5 +EcranX shl 1;
      Move (EcrnTxt[Vram],SavEcrnTxt[Vram],160);
      EcriTc ('Voulez-vous vraiment quitter ? Pressez sur ''O'' pour confirmation.',14+6*16);
      if UpCase(LitTouche)='O' then begin
        PosX (0); EcriTh (80,' '); PosY (EcranY-1);
        Ecrit ('Efface le fichier : ');
        Close (FichDst);
        Erase (FichDst);
        EcriTcr ('supprim',10);
        Fin (FALSE);
      end;
      Move (SavEcrnTxt[Vram],EcrnTxt[Vram],160);
    end;
  until FilePos(FichSrc)=FileSize(FichSrc);

  { Ecrit le message de fin : termin }
  with BarreAvancement do begin
    EcriTxh  (PourcX-3,y,80-(PourcX-3),' ');   { Efface le texte prcdent   }
    EcriTxcr (PourcX-3,y,'termin',15);        { Ecrit 'termin'             }
  end;

  Close (FichSrc);
  Close (FichDst);

  CopieFichier := TRUE;
end;

procedure CopieTousLesFichiers; begin
  { Copie le script d'installation }
  Ecrit ('Cre le script d''installation : ');
  CopieFichier (NomFichCRC,'A:\' +NomFichCRC,TRUE);

  { Copie le programme d'installation }
  Ecrit ('Copie le programme d''installation : ');
  CopieFichier (SauveRep+NomFichInstall,'A:\' +NomFichSansRep(NomFichInstall),TRUE);
end;

procedure Init; begin
  ProcAppeleeStop := PrepareFin;

  { Le programme est lanc  partir d'une disquette ? Non, il ne faut pas }
  GetDir (0,txt); txt[1] := UpCase(txt[1]);
  if (txt[1]='A') or (txt[1]='B') then begin
    EcriTcr ('Ce programme doit tre excut  partir d''un disque dur !',12);
    Halt (2);
  end;

  { Efface l'cran texte }
  EffaceEcranTxt;

  { Le programme d'installation est dans les parages (mme rpertoire) ? }
  if not FichierExistant(NomFichInstall) then
    if not FichierExistant(NomFichInstall) then
      StopProgramInfo ('initialisation','Programme d''installation introuvable',
                       'Nom du fichier : '+NomFichInstall);

  { Demande le nom du fichier si non fournit }
  if ParamStr(1)='' then begin
    { Affiche le texte }
    EcriTcr  ('Veuillez entrer le nom du fichier  dcouper (rpertoire + nom + extension) :',15+1*16);
    EcriThc (80,' ',14);
    SauteLigne;
    EcriTc  ('Remarque:',15+3*16); EcriTr  (' Vous pouvez aussi lancer ''Decoupe.exe'' suivi du nom du fichier.');
    EcriTc  ('Exemple :',15+3*16); EcriTcr (' Decoupe fichier.zip',10);
    EcriTr  ('');
    EcriTc  ('Astuce  :',15+3*16); EcriTr (' Sous Windows 95/98/2000 crez un raccourci avec la ligne de commande');
    Ecrit   ('          '''); EcriTc ('C:\Repertoire\Decoupe ?',10); EcriTr (''' (o Repertoire est le rpertoire o est');
    Ecrit   ('          '); EcriTr ('install l''utilitaire Decoupe).');
    EcriTr  ('');
    EcriTxc (-1,EcranY,'--- Appuyez sur Entre pour quitter ---',13);
    PosXY (0,EcranY-9);

    { Demande le nom du fichier }
    ReadLn (NomFich);
    if NomFich='' then Fin (TRUE);

    { Efface la remarque }
    EffaceEcranTxt;
  end else NomFich := ParamStr(1);

  { Alloue le tampon mmoire (tente d'avoir 65Ko) }
  TailleTampon := $FFFF;
  if MemAvail<TailleTampon then TailleTampon := MemAvail;
  if TailleTampon<TailleTamponMin then begin
    Str (MemAvail,txt);
    Str (TailleTamponMin,TmpTxt);
    StopProgram ('l''allocation du tampon mmoire de copie',
                 'Mmoire insuffisante : '+txt+' octets libre contre les '+TmpTxt+' ncessaires');
  end;
  GetMem (Tampon, TailleTampon);

  { Ouvre le fichier }
  TestErreurFich (OuvreFichier (F,0,NomFich,''),'ouverture du fichier  dcouper',NomFich);
  TailleTotalFich := FileSize(F);
end;

procedure AfficheInfoFichier; begin
  { Ecrit les infos sur le fichier }
  CoulTxt := 7;
  EcriTcr ('[ Informations sur le fichier ]',15+3*16);
  Ecrit ('Nom        : '); EcriTcr (NomFichSansRep(NomFich),10);
  Ecrit ('Rpertoire : '); txt := RepertoireNomFich (NomFich);
  if txt='' then EcriTcr ('(courant)',10) else EcriTcr (txt,10);
  Ecrit ('Taille     : '); EcriTnc (TailleTotalFich,10); EcriTr (' octets');

  { Choix de la taille des tranches }
  TailleTranche := TailleDisquette;

  { Calcule le nombre de disquette }
  TmpL := TailleTotalFich +TailleFichier(SauveRep+NomFichInstall) +TailleFichCRC;
  if TmpL<TailleTranche then begin
    EcriTcr ('Dcouper un fichier en un fichier est inutile ...',12);
    Fin (FALSE);
  end;
  FichCRC.NbrFichier := TmpL div TailleTranche +1;
  Ecrit ('Disquettes ncessaires : ');
  EcriTnc (FichCRC.NbrFichier,10); EcriTcr (' disquettes',10);
  EcriTr ('');
  EcriTc ('Remarque:',14+1*16); EcriTr (' Si l''espace disponible sur les diffrentes disquettes est infrieur ');
  EcriTr ('          1.44 Mo, plus de disquettes seront requises.');
  EcriTr ('');
end;

begin
  Init;

  AfficheInfoFichier;

  { Demande la nom de l'installation }
  with FichCRC do begin
    EcriTcr ('Entrez le nom de l''installation (tapez echape pour quitter) :',15);
    Ecrit ('Installation '); txt := '';
    if LitTxt (txt,SizeOf(NomInstall)-1,15+2*16,14+1*16)=FALSE then Fin (TRUE);
    EnleveEspace (txt);
    NomInstall := txt;
  end;

  { Rentre dans le rpetoire o est situ le fichier }
  GetDir (0,SauveRep);
  if SauveRep[length(SauveRep)]<>'\' then SauveRep := SauveRep+'\';

  txt := RepertoireNomFich (NomFich);
  if txt<>'' then ChDir (txt);
  EcriTr ('');

  { Tout cela est correct ? Demande confirmation }
  EcriTr ('');
  EcriTcr ('Tapez echape pour quitter ou une autre touche pour confirmer.',13);
  PosY (EcranY-2);
  EcriTc ('Ces informations sont-elles exactes ? ',15);
  ch := LitTouche;
  PosX (0); EcriTh (80*2,' '); PosY (EcranY-2);
  if ch=_ECHAPE then Fin (FALSE);

  { Dcoupe le fichier }
  CurseurOff;
  EcriTcr ('[ Dcoupe des fichiers sur le disque dur ]',15+3*16);

  { Prpare le fichier CRC }
  FichCRC.Signature   := SignatureCRC;
  FichCRC.Version     := VersionCRC;
  FichCRC.NomFich     := NomFichSansRep(NomFich);
  FichCRC.TailleTotal := TailleTotalFich;

  { Cre le fichier CRC }
  CreeFichier (FichDst,NomFichCRC);
  BlockWrite (FichDst, FichCRC, SizeOf(FichierCRC));
  Close (FichDst);

  { Dcoupe le fichier }
  TailleRestTotal := TailleTotalFich; i := 0;
  repeat
    { Demande  insrer la disquette ni }
    EcriTc ('Veuillez insrer la disquette n',15+2*16); EcriTnc (i+1,14+2*16);
    EcriTcr (', puis enfoncez une touche.',15+2*16);
    if LitTouche=_ECHAPE then Fin (FALSE);
    if i=0 then begin
      while DiskFree(1)<TailleMinDisq1 do begin
        Ecrit ('La premire disquette doit avoir au moins '); EcriTnc (TailleMinDisq1,14); Ecrit (' octets libres.');
        ch := LitTouche;
        PosX (0); EcriTh (80,' '); PosY (EcranY-1);
        if ch=_ECHAPE then Fin (FALSE);
      end;
      PosXY (0,EcranY-1); EcriTh (80,' '); PosY (EcranY-1);
      CopieTousLesFichiers;
    end else begin
      while DiskFree(1)<TailleMinDisq do begin
        Ecrit ('La disquette doit avoir au moins '); EcriTnc (TailleMinDisq,14); Ecrit (' octets libres.');
        ch := LitTouche;
        PosX (0); EcriTh (80,' '); PosY (EcranY-1);
        if ch=_ECHAPE then Fin (FALSE);
      end;
      PosXY (0,EcranY-1); EcriTh (80,' '); PosY (EcranY-1);
    end;

    { Calcul la taille de la tranche }
    TailleFich := DiskFree(1);
    if TailleRestTotal<TailleFich then TailleFich := TailleRestTotal;

    { Cre le nom du fichier }
    Str (i,TmpTxt);
    while length(TmpTxt)<3 do TmpTxt := '0' + TmpTxt;
    NomFichTranche := NomFichSansExt(NomFich)+'.'+TmpTxt;

    { Ecrit le nom du fichier }
    Ecrit ('Cre le fichier '''); EcriTc (NomFichSansRep(NomFichTranche),10);
    Ecrit (''' : ');

    { Cre le fichier }
    TestErreurFich (CreeFichier (FichDst,NomFichTranche),NomFichTranche,'cration d''une tranche');

    TailleTmp := TailleTampon;
    TailleEcritRest := TailleFich;
    repeat
      if TailleEcritRest<TailleTampon then TailleTmp := TailleEcritRest;

      BlockRead  (F,       Tampon^, TailleTmp);
      BlockWrite (FichDst, Tampon^, TailleTmp);

      dec (TailleEcritRest,TailleTmp);
    until TailleEcritRest=0;

    Close (FichDst);

    { Copie la tranche sur une disquette }
    if not CopieFichier (NomFichTranche,'A:\' +NomFichSansRep(NomFichTranche),TRUE) then
      Fin (FALSE);

    { Efface la tranche }
    TestErreurFich (OuvreFichier (FichDst,0,NomFichTranche,''),NomFichTranche,'ouverture du fichier  supprimer');
    Close (FichDst);
    Erase (FichDst);

    { Passe au fichier suivant }
    inc (i);

    { Reste-il quelque-chose  copier ? }
    dec (TailleRestTotal,TailleFich);
  until TailleRestTotal=0;
  Close (F);

  { Prpare le fichier CRC }
  if i<>FichCRC.NbrFichier then begin
    FichCRC.NbrFichier := i;

    { ReCre le fichier CRC }
    Ecrit ('Le nombre de disquette estim s''est avr incorrect : ');
    CreeFichier (FichDst,NomFichCRC);
    BlockWrite (FichDst, FichCRC, SizeOf(FichierCRC));
    Close (FichDst);
    EcriTcr ('recre',10);

    { ReDemande la disquette 1 }
    EcriTc ('Veuillez rinsrer la disquette n',15+2*16); EcriTnc (1,14+2*16);
    EcriTcr (', puis enfoncez une touche.',15+2*16);
    if LitTouche=_ECHAPE then Fin (FALSE);
    while FichierExistant('A:\'+NomFichCRC)=FALSE do begin
      EcriTc ('- La premire disquette SVP -',13);
      ch := LitTouche;
      PosX (0); EcriTh (80,' '); PosY (EcranY-1);
      if ch=_ECHAPE then Fin (FALSE);
    end;
    PosXY (0,EcranY-1); EcriTh (80,' '); PosY (EcranY-1);

    { Remplace le script d'installation }
    Ecrit ('Remplace le script d''installation : ');
    CopieFichier (NomFichCRC,'A:\' +NomFichCRC,TRUE);
  end;

  { Efface le script d'installation du disque dur }
  if FichierExistant(NomFichCRC) then begin
    txt := NomFichCRC; TestErreurFich (OuvreFichier (FichDst,0,txt,''),txt,'ouverture du script  supprimer');
    Close (FichDst);
    Erase (FichDst);
  end;

  { Fin du programme }
  Fin (FALSE);
end.