(*Ŀ
$ Source $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.haypo.fr.st/ $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                                                                            
   Cette utilitaire permet de reconstuire un fichier qui a t dcoup avec 
 le programme 'Decoupe'.                                                    
Ĵ
  Version    Consultez le fichier 'UNITE\A-Lire.txt' pour comprendre      
    les caractres dbutant les lignes.                          
                                                                            
 06/10/1999 => Version 0.0 (cration)                                       
 07/10/1999 => Version 0.1 (fonction principale installe (reconstitution   
    d'un fichier  partir de plusieurs tranches)                            
 08/10/1999 => Version 0.2                                                  
    + Ajout de la barre d'avancement                                        
    * Modification du format de fichier CRC : v0.1                          
      - Nom du programme  installer                                        
      - Rpertoire source                                                   
      - Rpertoire destination                                              
 12/10/1999 => Version 0.3.0                                                
    + Ajout d'une estimation du temps restant                               
    + Support de l'installation  partir d'une disquette                    
    + Vrification de l'espace disque disponnible                           
    * Modification du format de fichier CRC : v0.2                          
      - Version sur deux caractres ('02' signifie version 0.2)             
 13/10/1999 => Version 0.4.0                                                
    * Rorganisation du programme : dcoup en plusieurs procdures         
    + Posibilit de reprendre une installation stoppe (crash)              
 16/10/1999 => Version 0.5.0                                                
    * Modification du fichier CRC : v0.3 -> Rorganisation interne          
    + Format de fichier CRH : v0.1 -> Version bta                          
    + Format de fichier CRH : v0.2 -> +FichIouvert +PosFichI                
    ! Reprise d'une installation choue oprationnel                       
 27/10/1999 => Version 0.5.1                                                
    ! Correction de la barre d'avancement principale : en fonction des      
      octets copis et non du nombre de fichiers copis                     
 04/11/1999 => Version 0.5.2                                                
    * Affiche le texte '> 1 seconde' si le temps d'installation est         
      infrieur  1 seconde  la place du '???'                             
 08/11/1999 => Version 0.5.3                                                
    * Affiche le texte '< 5 secondes' si le temps d'installation est        
      infrieur  5 secondes  la place de '> 1 seconde'                    
    ! Dbogage du texte 'termin' -> efface le texte prcdent              
 18/11/1999 => Version 0.5.4                                                
    * Mise  jour des type InstallCRC et InstallCRH :                       
      - NomInstall = String[62]                                             
    - Suppresion de RepSrc (toujours A:\) et RepDst devient rpertoire      
    * Affiche le texte '< 1 seconde' si le temps d'installation est         
      infrieur  1 seconde                                                 
    * Utilisation de l'unit 'GestFich'                                     
 21/11/1999 => Version 0.5.5                                                
    * Mise  jour pour dcoupe 0.5.1 :                                      
      - InstallCRC : suppression du rpertoire                              
      - InstallCRH : rpertoire avec 255 caractres max                     
    * Demande toujours le rpertoire destination                            
    + Support des erreurs d'criture                                        
Ĵ
  Facults futures                                                        
                                                        
                                                                            
 Attention "future" signifit "en cours de dveloppement" mais ce dvelop-   
 pement peut tre trs long ou ne jamais aboutir. Si vous pouvez m'aider   
 ajouter ces facults, envoyez moi un email : haypo@ifrance.com.            
                                                                            
 * Support des noms-longs.                                                  
*)

{$A+: Utilise des adresses paire (plus rapide)                               }
{$B+: Optimise les valuations logiques                                      }
{$D-: N'insre pas d'informations pour le dboggage                          }
{$G+: Utilise les instructions du 286 (SHL/SHR/ENTER/LEAVE)                  }
{$I-: Ne teste pas les erreurs d'entre/sortie                               }
{$N-: N'utilise pas le co-processeur arithmtique                            }
{$Q-: Ne teste pas les erreurs de dbordement (Word(65535+1) par exemple)    }
{$R-: Ne teste pas les erreurs de domaine (Tableau, ex: EcrnTxt[4050])       }
{$S-: Ne teste pas le dbordement de la pile (8192 octets suffisent)         }
{$X+: Ne demande pas de variable pour stocker le rsultat d'une fonction     }

{$M 4096,0,65535}

uses
  Clavier,    { Interface utilisateur                                        }
  EcranTxt,   { Ecrit du texte en couleur                                    }
  GestFich,   { Gestion des fichiers                                     }
  GestStrg,   { Gestion des chaines de caractres                            }
  StopProg;   { Stoppe le programme avec un message d'erreur standardis     }

const
  Version = '0.5.5';
  Email   = 'haypo@ifrance.com';
  PageWeb = 'http://www.haypo.fr.st/';

  RepSrc  = 'A:\';

type
  FichierCRC = record { Script d'installation (Installation vierge)          }
    Signature   : Array[0..2] of char;  { = 'HYP'                            }
    Version     : Array[0..1] of char;  { XY signifie version X.Y            }
    NomFich     : String[12];           { abcdefgh.ijk                       }
    NomInstall  : String[62];           { Nom de l'installation              }
    TailleTotal : LongInt;              { Taille du fichier complet          }
    NbrFichier  : Word;                 { Nombre de disquettes               }
  end;

  FichierCRH = record { Fichier 'crash' (installation choue)               }
    Signature    : Array[0..2] of char; { = 'HYP'                            }
    Version      : Array[0..1] of char; { XY signifie version X.Y            }
    NomFich      : String[12];          { abcdefgh.ijk                       }
    NomInstall   : String[62];          { Nom de l'installation              }

    NbrFichCopie : Word;                { Nombre de disquettes copies       }
    NbrFichier   : Word;                { Nombre de disquettes total         }

    FichIouvert  : Boolean;             { Fichier ni ouvert ?               }
    PosFichI     : LongInt;             { Position de ce fichier             }

    TailleCopie  : LongInt;             { Taille dj copie                 }
    TailleTotal  : LongInt;             { Taille du fichier complet          }
    Repertoire   : String;              { Rpertoire destination : emplace-  }
                                        { ment o sera reform le fichier    }
  end;                                  { complet.                           }

  UnTampon = array[0..0{en faite = $FFFF}] of byte;

const
  { Signature HAYPO des formats de fichier }
  SignatureHYP  = 'HYP';

  { Fichier CRC (Script d'installation) }
  NomFichCRC     = 'install.crc';
  NomFichInstall = 'install.exe';      { Programme d'installation            }
  VersionCRC     = '05';
  TailleFichCRC  = SizeOf(FichierCRC);

  { Fichier CRH (Crash) }
  NomFichCRH    = 'crash.crh';
  VersionCRH    = '05';
  TailleFichCRH = SizeOf(FichierCRH);

  { Tampon mmoire }
  TailleTamponMin = 2048;              { Taille minimale : 2048 octets (2 Ko }

var
  { Le fichier }
  F: File;                             { Tranche de fichier ou autre         }
  Dest: File;                          { Futur fichier complet               }
  erreur: byte;                        { Erreur                              }
  NomFichTranche,                      { Nom de la tranche en cours de copie }
  RepDst: String;                      { Rpertoire o est recre le fichier }
  SauveRep: String;                    { Rpertoire d'o le programme est    }
                                       { lanc                               }
  IndexFich: Word;                     { Index de la tranche de fichier en   }
                                       { cours de copie                      }
  TailleTmp,                           { Taille de la partie copie          }
  OctetCopie,                          { Nombre d'octets dj copis         }
  OctetRestTotal,                      { Nombre d'octets restant  tre copi}
  TailleTranche: LongInt;              { Taille de la tranche en cours de    }
                                       { copie }
  FichCRC: FichierCRC;                 { Script d'installation               }
  FichCRH: FichierCRH;                 { Sauvegarde d'une installation qui a }
                                       { choue                             }

  { Tampon mmoire pour la copie }
  Tampon: ^UnTampon;                   { Pointeur sur l'espace mmoire allou}
  TailleTampon: Word;                  { Taille de cet espace                }

  { Barre d'avancement }
  BarreAvancement : array[1..2] of record
    Avance : Byte;                     { Son avance (en caractre)           }
    Larg   : Byte;                     { Sa largeur (en caractre)           }
    X,Y    : byte;                     { Sa position                         }
  end;

  { Chonomtre }
  Chrono : LongInt absolute $0040: $006C;   { Chronomtre systme            }
  SauveChrono: LongInt;                { Sauvegarde de celui-ci pour pouvoir }
                                       { calculer une dure en click (1/18s) }

  { Estimation du temps restant de l'installation }
  Vitesse : record
    OctetLect,OctetEcrt,               { Total des octets lus/crits         }
    DureeLect,DureeEcrt: LongInt;      { Dure de la lecture/criture de ces }
                                       { octets                              }
    X,Y : Byte;                        { Position du texte                   }
  end;
  Vitesse2 : record X,Y: Byte end;

  { Autres variables }
  Crash: Boolean;                      { Reprend une installation choue ?  }
  TxtSuppY: byte;                      { Position Y du texte supplmentaire :}
                                       { Erreur de lecture, demande de       }
                                       { changer de disquette, demande de    }
                                       { confirmation pour quitter           }

  { Variables trs temporaire }
  txt,TmpTxt,TmpTxt2: String;
  i,TmpO,
  TmpL,TmpL2: LongInt;
  TmpB: Boolean;
  ch: char;

procedure PrepareFin; far; begin
  { Retourne dans le rpetoire du dbut }
  if SauveRep<>'' then ChDir (SauveRep);

  { Rend le mmoire allou }
  if Tampon<>NIL then FreeMem (Tampon, TailleTampon);

  CurseurOn;
end;

procedure Fin; begin
  PrepareFin;

  { Affiche le message d'adieu }
  EcriTc ('InstallCRC',15+1*16); EcriTc (' v',7+1*16); EcriTcr (Version,14+1*16);
  EcriT ('Crateur: '); EcriTcr ('Haypo ',10);
  EcriT ('Email   : '); EcriTcr (Email,10);
  EcriT ('Sources : '); EcriTcr (PageWeb,10);
  Halt;
end;

procedure TestErreurFich (Erreur: Byte; NomFich,Quand: String); begin
  if erreur=0 then exit;

  PrepareFin;
  StopProgram (Quand+' (fichier '''+NomFich+''')',TxtErreurFich(Erreur));
end;

procedure CopieFichier (NomFich: String; NomFichDst: String); begin
  { Ouvre le fichier source }
  TestErreurFich (OuvreFichier (F,2,NomFich,''),NomFich,'ouverture du source  copier');

  { Cre (ou remplace) le fichier destination }
  TestErreurFich (CreeFichier (Dest,NomFichDst),NomFichDst,'cration du fichier destination');

  if FileSize(F)=0 then begin
    EcriTc ('Fichier de taille nulle !',12);
    Close (F);
    Close (Dest);
  end;

  { Prpare la seconde barre d'avancement }
  with BarreAvancement[1] do begin
    Y := EcranY;
    EcriTc ('000',9); {PourcX := X-2}; Ecrit('% '); {BarreX := X;} X := EcranX;
    Larg := 80-EcranX-13; EcriTh (Larg,'');

    Ecrit (' '); Vitesse.X := EcranX; Vitesse.Y := EcranY;

    EcriTc ('estimation',15); EcriTh (80-EcranX,' ');
  end;

  TxtSuppY := EcranY +1;

  { Initialise l'estimation de temps }
  with Vitesse do begin
    OctetLect := 0; OctetEcrt := 0;
    DureeLect := 0; DureeEcrt := 0;
  end;

  { Copie le contenu du fichier source dans le fichier destination }
  TailleTmp := TailleTampon;
  repeat
    if FileSize(F)-FilePos(F)<TailleTmp then
      TailleTmp := FileSize(F)-FilePos(F);

    { Actualise la barre d'avancement }
    with BarreAvancement[1] do with FichCRC do begin
      EcriTxhc (X,Y,FilePos(F)*Larg div FileSize(F),'',10);
      Str (FilePos(F)*100 div FileSize(F),TmpTxt);
      EcriTxc (X-2-length(TmpTxt),Y,TmpTxt,14);
    end;

    { Lecture d'un bloc et calcul de la vitesse de lecture }
    SauveChrono := Chrono;
    {$I-} BlockRead (F,Tampon^, TailleTmp); {$I+}
    if IOResult<>0 then begin
      PosXY (0,TxtSuppY);
      Move (EcrnTxt,SavEcrnTxt,4000);
      EcriTcr ('Erreur de lecture. Enfoncez une touche pour ressayer ou echape pour quitter.',14+6*16);
      EcriTc ('> ',15); Ecrit (TxtErreurFich(erreur));
      TmpTxt := '- Nouvel essai - ';
      ch := LitTouche;
      PosX (0); EcriTh (79,' '); PosX (0);
      repeat
        if LitTouche=_ECHAPE then Fin;
        EcriTc (TmpTxt,13);
        {$I-} BlockRead (F,Tampon^, TailleTmp); {$I+}
        AttendEcran; AttendEcran;
        PosX (0); EcriTh (Length(TmpTxt),' '); PosX (0);
      until IOResult=0;
      Move (SavEcrnTxt,EcrnTxt,4000);
      ch := #0;
    end else with Vitesse do begin
      inc (DureeLect, Chrono-SauveChrono );
      inc (OctetLect, TailleTmp);
    end;

    { Ecrit la partie du fichier }
    SauveChrono := Chrono;
    {$I-} BlockWrite (Dest, Tampon^, TailleTmp); {$I+}
    if IOResult<>0 then begin
      PosXY (0,TxtSuppY);
      Move (EcrnTxt,SavEcrnTxt,4000);
      EcriTcr ('Erreur d''criture. Enfoncez une touche pour ressayer ou echape pour quitter.',14+6*16);
      EcriTc ('> ',15); Ecrit (TxtErreurFich(erreur));
      TmpTxt := '- Nouvel essai - ';
      ch := LitTouche;
      PosX (0); EcriTh (79,' '); PosX (0);
      repeat
        if LitTouche=_ECHAPE then Fin;
        EcriTc (TmpTxt,13);
        {$I-} BlockWrite (Dest, Tampon^, TailleTmp); {$I+}
        AttendEcran; AttendEcran;
        PosX (0); EcriTh (Length(TmpTxt),' '); PosX (0);
      until IOResult=0;
      Move (SavEcrnTxt,EcrnTxt,4000);
      ch := #0;
    end else with Vitesse do begin
      inc (DureeEcrt, Chrono-SauveChrono );
      inc (OctetEcrt, TailleTmp);
    end;

    with Vitesse do begin
      { Calcule le temps restant de l'installation }
      PosXY (X,Y);
      if DureeLect<>0 then TmpL := (FileSize(F)-FilePos(F)) div (19*OctetLect div DureeLect) else TmpL := 0;
      if DureeEcrt<>0 then inc(TmpL, (FileSize(F)-FilePos(F)) div (19*OctetEcrt div DureeEcrt));

      { Ecrit la dure au format horaire (h:m:s, m:s ou s) }
      if 0<TmpL then begin
        if 3600<TmpL then begin
          Str (TmpL div 3600,txt);
          TmpL := TmpL mod 3600;

          Str (TmpL div 60,TmpTxt);
          TmpL := TmpL mod 60;
          txt := txt+'h '+TmpTxt+'min';

          Str (TmpL,TmpTxt);
          txt := txt+'s';
        end else begin
          if 60<TmpL then begin
            Str (TmpL div 60,txt);
            Str (TmpL mod 60,TmpTxt);
            txt := txt+'min '+TmpTxt+'s';
          end else begin
            Str (TmpL,txt);
            txt := txt+' seconde';
            if 1<TmpL then txt := txt+'s';
          end;
        end;
      end else txt := '< 1 seconde';
      EcriTc (txt,15); if EcranX<80 then EcriTh (80-EcranX,' ');
    end;
  until FilePos(F)=FileSize(F);

  { Ecrit le message de fin : termin }
  with BarreAvancement[1] do begin
    EcriTxh  (X-5,y,80-X+5-1,' ');        { Efface le texte prcdent   }
    EcriTxcr (X-5,y,'termin',15);        { Ecrit 'termin'             }
  end;

  Close (F);
  Close (Dest);
end;

procedure SauveEtatInstall (FichCopieCours: Boolean); begin
  EffaceEcranTxt; CurseurOn;

  { Demande si on veut sauver l'tat de l'installation }
  Ecrit ('Voulez-vous reprendre l''installation plus tard (O/N) ? ');
  ch := UpCase(LitTouche);
  if ch<>'O' then EcriTcr ('non',10) else EcriTcr ('OUI !',15);

  if ch='O' then begin
    Ecrit ('Cre le fichier de sauvegarde de l''installation : ');

    { Prpare l'en-tte du fichier crash }
    with FichCRH do begin
      Signature    := SignatureHYP;
      Version      := VersionCRH;
      NomFich      := FichCRC.NomFich;
      NomInstall   := FichCRC.NomInstall;

      NbrFichCopie := IndexFich;
      NbrFichier   := FichCRC.NbrFichier;

      FichIouvert  := FichCopieCours;
      if FichCopieCours then PosFichI := FilePos(F) else PosFichI := 0;

      TailleCopie  := FilePos(Dest);
      TailleTotal  := FichCRC.TailleTotal;

      Repertoire   := RepDst;
    end;
    Close (Dest);

    { Cre le fichier CRH (crash) }
    TestErreurFich ( CreeFichier (F,NomFichCRH), NomFichCRH, 'cration de la sauvegarde d''installation');

    { Ecrire les donnes }
    BlockWrite (F, FichCRH, SizeOf(FichierCRH));

    { Ferme le fichier }
    Close (F);

    EcriTcr ('OK',15);

    { Copie le fichier d'installation }
    if not FichierExistant(NomFichInstall) then begin
      { La disquette 1 est insre ? Si c'est non, la demande }
      if not FichierExistant(SauveRep+NomFichInstall) then begin
        EcriTc ('Insrez le disquette numro ',15+2*16); EcriTnc (IndexFich+1,14+2*16);
        EcriTcr (', puis pressez une touche, SVP.',15+2*16);
        TmpTxt := '- Lit la disquette - '; TmpB := FALSE;
        repeat
          { Attend la pression d'une touche. Est-ce la touche echape ? }
          if UpCase (LitTouche)=_ECHAPE then begin
            if IndexFich=0 then EffaceEcranTxt else SauveEtatInstall (FALSE);
            Fin;
          end;

          { Affiche un texte et lit la disquette }
          EcriTc (TmpTxt,13);
          TmpB := FichierExistant(SauveRep+NomFichInstall);
          AttendEcran; AttendEcran;
          PosX (0); EcriTh (length(TmpTxt),' '); PosX (0);
        until TmpB;
      end;

      Ecrit ('Copie le programme d''installation : ');
      CopieFichier(SauveRep+NomFichInstall,NomFichInstall);
    end;
    EcriTr ('');

    EcriThc (80*3,' ',15+3*16); PosY (EcranY-3);
    EcriTcr ('Pour reprendre l''installation, entrez dans le rpertoire :',15+3*16);
    EcriTc (RepDst,14+1*16); EcriThc (80-EcranX,' ',14+1*16);
    EcriTcr ('Et lancez '''+NomFichInstall+'''.',15+3*16);
  { Efface le fichier copi partiellement }
  end else begin
    if FichCopieCours then Close (F);

    { Futur fichier complet existant ? Oui, le supprime }
    if FichierExistant(FichCRC.NomFich) then begin
      Ecrit ('Efface le fichier copi partiellement : ');
      txt := FichCRC.NomFich; OuvreFichier (F, 0, txt, ''); Close(F); Erase (F);
      EcriTcr ('supprim',10);
    end;

    { Sauvegarde d'installation choue existante ? Oui, la supprime }
    if FichierExistant(NomFichCRH) then begin
      Ecrit ('Efface la sauvegarde de l''installation choue : ');
      txt := NomFichCRH; OuvreFichier (F, 0, txt, ''); Close (F); Erase (F);
      EcriTcr ('supprime',10);
    end;
  end;
  EcriTr ('');
end;

procedure LitScriptInstall; begin
  Ecrit ('Lecture du script d''installation ('+NomFichCRC+') ... ');

  { Existe-il ? }
  if not FichierExistant (NomFichCRC) then begin
    EcriTcr ('introuvable',12);
    Halt;
  end;

  { Lit le fichier CRC }
  with FichCRC do begin
    { Ouvre le fichier }
    txt := NomFichCRC;
    OuvreFichier (F,0,txt,'crc');

    { Taille correcte ? }
    if FileSize(F)<>TailleFichCRC then
      StopProgram ('l''analyse du fichier CRC','Taille (ou version ?) incorrecte');

    { Lit l'en-tte puis le ferme }
    BlockRead (F, FichCRC, SizeOf(FichierCRC));
    Close (F);

    { Signature correcte ? }
    if Signature<>SignatureHYP then
      StopProgram ('l''analyse du fichier CRC','Signature incorrecte');

    { Version correcte ? }
    if Version<>VersionCRC then
      StopProgram ('l''analyse du fichier CRC','Version non gre');

    if NomFich='' then
      StopProgram ('l''analyse du fichier CRC','Nom du fichier complet incorrect');
  end;

  EcriTcr ('OK',15);
end;

procedure ChargeEtatCrash; begin
  Ecrit ('Lit le fichier de sauvegarde de l''installation : ');

  with FichCRH do begin
    { Tente d'ouvrir le fichier, si une erreur se produit -> quitte }
    txt := NomFichCRH;
    if OuvreFichier (F,0,txt,'crh')<>0 then begin
      Crash := FALSE;
      Exit;
    end;

    { Taille correcte ? Non, recommence l'installation  zro }
    if FileSize(F)<>TailleFichCRH then begin
      EcriTcr ('Taille incorrecte',12);
      Crash := FALSE; Exit;
    end;

    { Lit l'en-tte puis le ferme }
    BlockRead (F, FichCRH, SizeOf(FichierCRH));
    Close (F);

    { Signature correcte ? }
    if Signature<>SignatureHYP then begin
      EcriTcr ('Signature incorrecte',12);
      Crash := FALSE; Exit;    end;

    { Version correcte ? }
    if Version<>VersionCRH then begin
      EcriTcr ('Version incorrecte',12);
      Crash := FALSE; Exit;
    end;

    { Copie les informations dans la variable FichCRC }
    FichCRC.NomFich := NomFich;
    FichCRC.TailleTotal := TailleTotal;
    FichCRC.NbrFichier  := NbrFichier;
    FichCRC.NomInstall  := NomInstall;
    RepDst              := Repertoire;
  end;

  EcriTcr ('OK',15);
end;

procedure CreeFichierDest; begin
  { Cre le fichier destination }
  if FichierExistant(FichCRC.NomFich) then begin
    txt := FichCRC.NomFich;
    OuvreFichier (Dest,0,txt,'');

    EcriTcr ('Le fichier '''+txt+''' existe dj dans le rpertoire destination.',14+6*16);
    CurseurOn;

    if FileSize(Dest)=FichCRC.TailleTotal then begin
      EcriTr ('Sa taille est identique  celle du fichier devant tre install. Enfoncez une');
      Ecrit ('touche pour quitter ou la touche ''R'' pour le remplacer.');
      if UpCase(LitTouche)<>'R' then begin EffaceEcranTxt; Fin end;
    end else begin
      EcriTr ('Il se peut qu''il provienne d''une installation choue car sa taille est');
      Ecrit ('diffrente. Enfoncez une touche pour le remplacer ou echape pour quitter.');
      if LitTouche=_ECHAPE then begin EffaceEcranTxt; Fin end;
    end;
    Close (Dest);

    CurseurOff;
    PosXY (0,EcranY-2); EcriTh (80*3,' '); PosY (EcranY-3);

    EcriTc ('Remplace le fichier ''',15);
  end else EcriTc ('Cre le fichier ''',15);

  EcriTc (FichCRC.NomFich,14); EcriTc (''' : ',15);
  TestErreurFich ( CreeFichier (Dest,FichCRC.NomFich), FichCRC.NomFich, 'cration du fichier destination');
  EcriTr ('OK');
  EcriTr ('');
end;

procedure TraiteRepertoire; begin with FichCRC do begin
  { Vrifit l'existance des rpertoires destination, dans le cas contraire : }
  { les cre }
  txt := RepDst;

  if txt<>'' then begin
    {$I-}
    ChDir (txt);
    if IOResult<>0 then begin
      { Rentre dans le bon disque }
      if Pos(':',txt)=0 then
        StopProgram ('recherche du rpertoire destination','Disque non spcifi');

      i := Pos('\',txt);
      TmpTxt := Copy (txt, 1, i);
      ChDir (TmpTxt);

      inc (i);
      TmpTxt := Copy (txt, i, length(txt)-i);

      while TmpTxt<>'' do begin
        TmpO := Pos ('\',TmpTxt);
        if TmpO<>0 then Delete (TmpTxt, TmpO, length(TmpTxt)-TmpO+1);

        { Sous-rpertoire inexistant ? Le cre }
        ChDir (TmpTxt);
        if IOResult<>0 then begin
          MkDir (TmpTxt);
          GetDir (0,TmpTxt2);
          EcriTc ('Cre le rpertoire ''',15); EcriTc (TmpTxt,14);
          EcriTc (''' dans ''',15); EcriTc (TmpTxt2,14); EcriTcr ('''.',15);
          ChDir (TmpTxt);
        end;

        inc (i,TmpO);
        TmpTxt := Copy (txt, i, length(txt)-i);
        if TmpO=0 then TmpTxt := '';
      end;
    end;
    {$I+}
  end else StopProgram ('lecture du script d''installation','Rpertoire destination abscent');
end end;

procedure AfficheInfoInstall; begin with FichCRC do begin
  EffaceEcranTxt;

  { Le titre }
  CoulTxt := 15+7*16;
  EcriTxh (0,0,80,'');
  txt := ' Installation '+NomInstall+' ';
  EcriTx (-1,0,txt);
  for i := 1 to (length(txt)-2)+1 do TmpTxt[i] := '';
  TmpTxt[0] := chr(length(txt) -2);
  TmpTxt := ''+TmpTxt+'';
  EcriTx ((80-length(txt)) shr 1,1,TmpTxt);
  CoulTxt := 7+0*16;
  PosXY (0,4);

  { Ecrit les informations sur le fichier }
  EcriTcr ('[ Informations sur le fichier  installer ]',15+3*16);
  Ecrit ('Nom                    : '); EcriTcr (NomFich,10);
  Ecrit ('Taille                 : '); EcriTnc (TailleTotal,10); EcriTr (' octets');
  Ecrit ('Nombre de disquette    : '); EcriTncr (NbrFichier,10);
  if not Crash then begin
    EcriTcr ('Entrez le rpertoire destination (tapez entre pour quitter) :',15);
    EcriThc (80,' ',10); PosY (EcranY-1);
    ReadLn (txt); EnleveEspace (txt);
    if txt='' then Fin;
    if txt[length(txt)]<>'\' then txt := txt+'\';
    RepDst := txt;
    txt := RepertoireValide(RepDst);
    if txt<>'' then
      StopProgram ('la capture du rpertoire',txt);
    PosY (EcranY-2); EcriTh (80*2,' '); PosY (EcranY-2);
  end else GetDir (0,RepDst);
  Ecrit ('Rpertoire destination : '); EcriTcr (RepDst,10);
end end;

procedure TenteContinuerInstallPlante; begin with FichCRH do begin
  Ecrit ('Tente de continuer l''installation stoppe : ');

  { Ouvre le fichier destination }
  txt := NomFich;
  if not FichierExistant(txt) then begin
    EcriTcr ('Fichier '''+txt+''' introuvable',12);
    Crash := FALSE; Exit;
  end;
  OuvreFichier (Dest,2,txt,''); FileMode := 2;

  { Positionne le fichier  la fin }
  If FileSize(Dest)<>TailleCopie then begin
    EcriTcr ('Taille incorrecte',12);
    Crash := FALSE; Exit;
  end;
  Seek (Dest, TailleCopie);

  IndexFich := NbrFichCopie;

  PosX (0); EcriTh (80,' '); PosY (EcranY-1);
end end;

procedure PrepareCopie; begin
  EcriTcr ('[ Installation ]',15+3*16); CurseurOff;

  { Tente de continuer l'installation l o elle s'est arrte }
  if Crash then begin
    TenteContinuerInstallPlante;

    { Erreur lors de la reprise ? Alors annule la reprise de l'installation  }
    { et recomme l'installation  zro                                       }
    if not Crash then begin
      EcriTcr ('Recommence l''installation au point de dpart.',14+4*16);

      { Efface le fichier destination s'il existe }
      if FichierExistant(FichCRC.NomFich) then begin
        txt := FichCRC.NomFich;
        Ecrit ('Efface le fichier install partiellement : ');
        OuvreFichier (Dest,0,txt,''); Close (Dest); Erase (Dest);
        EcriTcr ('supprim',10);
      end;
    end;
  end;

  { Installation vierge ? Alors cre le fichier desination }
  if not Crash then begin
    CreeFichierDest;
    IndexFich := 0;
  end;

  { Alloue le tampon mmoire (tente d'avoir 65Ko) }
  TailleTampon := $FFFF;
  if MemAvail<TailleTampon then TailleTampon := MemAvail;
  if TailleTampon<TailleTamponMin then begin
    Str (MemAvail,txt);
    Str (TailleTamponMin,TmpTxt);
    StopProgram ('l''allocation du tampon mmoire de copie',
                 'Mmoire insuffisante : '+txt+' octets libre contre les '+TmpTxt+' ncessaires');
  end;
  GetMem (Tampon, TailleTampon);

  { Prpare l'cran : laisse 6 lignes de libres }
  TxtSuppY := EcranY;
  if 24<TxtSuppY+6 then begin
    PosY (24);
    for i := 0 to (TxtSuppY+6)-24 do EcriTr ('');
    PosY (24-6);
  end;

  { Comment reste-il d'octets  copier ? }
  if Crash then
    with FichCRH do OctetRestTotal := TailleTotal - TailleCopie
  else
    with FichCRC do OctetRestTotal := TailleTotal;

  { Prpare la premire barre d'avancement }
  Ecrit ('Avancement total : '); EcriTc ('000',9); Ecrit ('% ');
  with BarreAvancement[1] do begin
    X := EcranX; Y := EcranY;
    Larg := 80-X-13;
    EcriTh (Larg,'');
  end;

  with Vitesse do begin
    X := BarreAvancement[1].X+BarreAvancement[1].Larg+1;
    Y := BarreAvancement[1].Y;
    OctetLect := 0; OctetEcrt := 0;
    DureeLect := 0; DureeEcrt := 0;

    Ecrit (' '); EcriTc ('???',15);
  end;

  { Actualise la premire barre d'avancement }
  with BarreAvancement[1] do with FichCRC do begin
    EcriTxhc (X,Y,(TailleTotal-OctetRestTotal)*Larg div TailleTotal,'',10);
    Str ((TailleTotal-OctetRestTotal)*100 div TailleTotal,TmpTxt);
    EcriTxc (X-length(TmpTxt)-2,Y,TmpTxt,14);
  end;

  { Prpare la seconde barre d'avancement }
  BarreAvancement[2].Y := Vitesse.Y+2;

  { Position Y du texte supplmentaire ? }
  TxtSuppY := BarreAvancement[2].Y +2;

  { Aucune touche presse }
  ch := #0;
end;

procedure EffectueCopie; begin
  FileMode := 2;

  repeat
    { Cre le nom du fichier ni (rep + nom + i) }
    Str (IndexFich,TmpTxt); while length(TmpTxt)<3 do TmpTxt := '0'+TmpTxt;
    NomFichTranche := RepSrc +NomFichSansExt(FichCRC.NomFich) +'.' +TmpTxt;

    { Changement de disquette ? }
    if (not FichierExistant(NomFichTranche)) then begin
      PosXY (0,TxtSuppY);
      Move (EcrnTxt,SavEcrnTxt,4000);
      EcriTc ('Insrez le disquette numro ',15+2*16); EcriTnc (IndexFich+1,14+2*16);
      EcriTcr (', puis pressez une touche, SVP.',15+2*16);
      TmpTxt := '- Lit la disquette - '; TmpB := FALSE;
      repeat
        { Attend la pression d'une touche. Est-ce la touche echape ? }
        if UpCase (LitTouche)=_ECHAPE then begin
          if IndexFich=0 then EffaceEcranTxt else SauveEtatInstall (FALSE);
          Fin;
        end;

        { Affiche un texte et lit la disquette }
        EcriTc (TmpTxt,13);
        TmpB := FichierExistant(NomFichTranche);
        AttendEcran; AttendEcran;
        PosX (0); EcriTh (length(TmpTxt),' '); PosX (0);
      until TmpB;
      Move (SavEcrnTxt,EcrnTxt,4000);
    end;

    { Ouvre le fichier ni }
    OuvreFichier (F,2,NomFichTranche,'');

    { Reprise d'une installation choue ? Alors reprend la copie l o }
    { elle s'est arrte                                                }
    if Crash then with FichCRH do begin
      if FichIouvert then Seek (F, PosFichI);
      if FichIouvert then OctetCopie := PosFichI else OctetCopie := 0;
      Crash := FALSE;
    end else OctetCopie := 0;
    TailleTranche := FileSize(F);

    { Prpare la seconde barre d'avancement }
    with BarreAvancement[2] do begin
      EcriTx (0,y,'Ajoute le fichier ''');
      EcriTc (NomFichSansRep(NomFichTranche),10);
      Ecrit (''' : '); EcriTc ('000',9); Ecrit('% '); X := EcranX;
      Larg := 80-X-13; EcriTh (Larg,'');

      Vitesse2.X := EcranX+1; Vitesse2.Y := EcranY;
      Ecrit (' '); EcriTc ('???',15); EcriTh (80-EcranX,' ');
    end;

    { Rinitialise l'estimation de temps }
    with Vitesse do begin
      OctetLect := 0; OctetEcrt := 0;
      DureeLect := 0; DureeEcrt := 0;
    end;

    { Copie le contenu du fichier source dans le fichier destination }
    TailleTmp := TailleTampon;
    repeat
      if TailleTranche-OctetCopie<TailleTampon then TailleTmp := TailleTranche-OctetCopie;

      { Actualise les barres d'avancement }
      with BarreAvancement[1] do with FichCRC do begin
        EcriTxhc (X,Y,(TailleTotal-OctetRestTotal)*Larg div TailleTotal,'',10);
        Str ((TailleTotal-OctetRestTotal)*100 div TailleTotal,TmpTxt);
        EcriTxc (X-length(TmpTxt)-2,Y,TmpTxt,14);
      end;

      with BarreAvancement[2] do begin
        Avance := OctetCopie*Larg div TailleTranche;
        EcriTxhc (X,Y,Avance,'',10);
        Str (OctetCopie*100 div TailleTranche,TmpTxt);
        EcriTxc (X-length(TmpTxt)-2,Y,TmpTxt,14);
      end;

      { Lecture d'un bloc et calcul de la vitesse de lecture }
      SauveChrono := Chrono;
      {$I-} BlockRead  (F,Tampon^, TailleTmp); {$I+}
      erreur := IOResult;

      { Une erreur s'est produite ? Si oui rpete jusqu' ce que a marche }
      if erreur<>0 then begin
        PosXY (0,TxtSuppY);
        Move (SavEcrnTxt,EcrnTxt,4000);
        EcriTcr ('Erreur de lecture. Enfoncez une touche pour ressayer ou echape pour quitter.',14+6*16);
        EcriTc ('> ',15); Ecrit (TxtErreurFich(erreur));
        TmpTxt := '- Nouvel essai - ';
        ch := LitTouche;
        PosX (0); EcriTh (79,' '); PosX (0);
        repeat
          if ch=_ECHAPE then begin
            SauveEtatInstall (TRUE);
            Fin;
          end;
          EcriTc (TmpTxt,13);
          {$I-} BlockRead  (F,Tampon^, TailleTmp); {$I+}
          AttendEcran; AttendEcran;
          PosX (0); EcriTh (Length(TmpTxt),' '); PosX (0);
          ch := LitTouche;
        until IOResult=0;
        Move (SavEcrnTxt,EcrnTxt,4000);
        ch := #0;
      end else with Vitesse do begin
        inc (DureeLect, Chrono-SauveChrono );
        inc (OctetLect, TailleTmp);
      end;

      { Ecriture d'un bloc et calcul de la vitesse d'criture }
      SauveChrono := Chrono;
      {$I-} BlockWrite (Dest, Tampon^, TailleTmp); {$I+}

      { Une erreur s'est produite ? Si oui rpete jusqu' ce que a marche }
      erreur := IOResult;
      if erreur<>0 then begin
        Move (EcrnTxt,SavEcrnTxt,4000);
        EcriTcr ('Erreur d''criture. Enfoncez une touche pour ressayer ou echape pour quitter.',14+6*16);
        EcriTc ('> ',15); Ecrit (TxtErreurFich(erreur));
        TmpTxt := '- Nouvel essai - ';
        ch := LitTouche;
        PosX (0); EcriTh (79,' '); PosX (0);
        repeat
          if ch=_ECHAPE then begin
            SauveEtatInstall (TRUE);
            Fin;
          end;
          EcriTc (TmpTxt,13);
          {$I-} BlockWrite (Dest, Tampon^, TailleTmp); {$I+}
          AttendEcran; AttendEcran;
          PosX (0); EcriTh (Length(TmpTxt),' '); PosX (0);
          ch := LitTouche;
        until IOResult=0;
        Move (SavEcrnTxt,EcrnTxt,4000);
        ch := #0;
      end else with Vitesse do begin
        inc (DureeEcrt, Chrono-SauveChrono );
        inc (OctetEcrt, TailleTmp);
      end;

      with Vitesse do begin
        { Calcule le temps restant de l'installation }
        PosXY (x,y);
        if DureeLect<>0 then TmpL := OctetRestTotal div (19*OctetLect div DureeLect) else TmpL := 0;
        if DureeEcrt<>0 then inc(TmpL, OctetRestTotal div (19*OctetEcrt div DureeEcrt));

        { Ecrit la dure au format horaire (h:m:s, m:s ou s) }
        if 0<TmpL then begin
          if 3600<TmpL then begin
            Str (TmpL div 3600,txt);
            TmpL := TmpL mod 3600;

            Str (TmpL div 60,TmpTxt);
            TmpL := TmpL mod 60;
            txt := txt+'h '+TmpTxt+'min';

            Str (TmpL,TmpTxt);
            txt := txt+'s';
          end else begin
            if 60<TmpL then begin
              Str (TmpL div 60,txt);
              Str (TmpL mod 60,TmpTxt);
              txt := txt+'min '+TmpTxt+'s';
            end else begin
              Str (TmpL,txt);
              txt := txt+'s';
            end;
          end;
        end else txt := '< 1 seconde';
        EcriTc (txt,15); if EcranX<80 then EcriTh (80-EcranX,' ');

        { Calcule le temps restant de la copie du fichier ni }
        PosXY (Vitesse2.X,Vitesse2.Y);
        TmpL2 := TailleTranche-OctetCopie;
        if DureeLect<>0 then TmpL := TmpL2 div (19*OctetLect div DureeLect) else TmpL := 0;
        if DureeEcrt<>0 then inc(TmpL, TmpL2 div (19*OctetEcrt div DureeEcrt));

        { Ecrit la dure au format horaire (h:m:s, m:s ou s) }
        if 0<TmpL then begin
          if 3600<TmpL then begin
            Str (TmpL div 3600,txt);
            TmpL := TmpL mod 3600;

            Str (TmpL div 60,TmpTxt);
            TmpL := TmpL mod 60;
            txt := txt+'h '+TmpTxt+'min';

            Str (TmpL,TmpTxt);
            txt := txt+'s';
          end else begin
            if 60<TmpL then begin
              Str (TmpL div 60,txt);
              Str (TmpL mod 60,TmpTxt);
              txt := txt+'min '+TmpTxt+'s';
            end else begin
              Str (TmpL,txt);
              txt := txt+'s';
            end;
          end;
        end else txt := '< 1 seconde';

        EcriTc (txt,15); if EcranX<80 then EcriTh (80-EcranX,' ');
      end;

      { Une touche a t presse ? Est-ce la touche chape ? }
      if TouchPresse then if LitTouche=_ECHAPE then begin
        PosXY (0,TxtSuppY);
        Move (EcrnTxt,SavEcrnTxt,4000);
        EcriTc ('Voulez-vous vraiment quitter ? Pressez sur ''O'' pour confirmation.',14+6*16);
        if UpCase(LitTouche)='O' then begin
          SauveEtatInstall (TRUE);
          Fin;
        end;
        Move (SavEcrnTxt,EcrnTxt,4000);
      end;

      inc (OctetCopie,TailleTmp);
      dec (OctetRestTotal,TailleTmp);
    until OctetCopie=TailleTranche;
    Close (F);
    inc (IndexFich);

    { Actualise la seconde barre d'avancement }
    with BarreAvancement[2] do begin
      Avance := OctetCopie*Larg div TailleTranche;
      EcriTxhc (X,Y,Avance,'',10);
      Str (OctetCopie*100 div TailleTranche,TmpTxt);
      EcriTxc (X-length(TmpTxt)-2,Y,TmpTxt,14);
    end;

    { Seconde estimation du temps : copie termine }
    with Vitesse2 do begin
      PosXY (x,y); EcriTh (80-x,' ');     { Efface le texte prcdent }
      PosXY (x,y); EcriTc ('termin',15); { Ecrit 'termin' }
    end;
  until IndexFich=FichCRC.NbrFichier;
end;

procedure TestFichierFinal; begin
  { La taille est celle indique dans le fichier CRC ? }
  if FilePos(Dest)<>FichCRC.TailleTotal then
    StopProgram ('la cration du fichier complet','Taille incorrecte');
  Close (Dest);

  { Message de succs }
  EffaceEcranTxt;
  GetDir (0,TmpTxt);
  EcriTr ('');
  EcriTxhc (4*4*4 shr 1,0,80-4*4*4,'',3);
  EcriTxhc (3*3*3 shr 1,1,80-3*3*3,'',3);
  EcriTxhc (2*2*2 shr 1,2,80-2*2*2,'',3);
  EcriTxhc (0*0*0 shr 1,3,80-0*0*0,'',3);
  EcriTxhc (0*0*0 shr 1,4,80-0*0*0,'',3);
  EcriTxhc (2*2*2 shr 1,5,80-2*2*2,'',3);
  EcriTxhc (3*3*3 shr 1,6,80-3*3*3,'',3);
  EcriTxhc (4*4*4 shr 1,7,80-4*4*4,'',3);

  txt := 'Installation russie, le fichier '''+FichCRC.NomFich+''' a t reconstruit avec succs';
  EcriTxc ((80-length(txt)) shr 1,3,'Installation russie, le fichier ''',15+3*16);
  EcriTc (FichCRC.NomFich,14+3*16);
  EcriTc (''' a t reconstruit avec succs',15+3*16);

  txt := 'dans le rpertoire '''+TmpTxt+'''.';
  EcriTxc ((80-length(txt)) shr 1,4,'dans le rpertoire ''',15+3*16);
  EcriTc (TmpTxt,14+3*16);
  EcriTc ('''.',15+3*16);

  { Attend la pression d'une touche }
  EcriTxc (-1,10,'--- Enfoncez une touche pour quitter ---',9);
  LitTouche;
  PosXY (0,10); EcriTh (80,' '); PosXY (0,10);

  { Sauvegarde d'installation choue existante ? Oui, la supprime }
  if FichierExistant(NomFichCRH) then begin
    Ecrit ('Efface la sauvegarde de l''installation choue : ');
    txt := NomFichCRH; OuvreFichier (F,0,txt,''); Close (F); Erase (F);
    EcriTcr ('supprime',10);
    EcriTr ('');
  end;

  Fin;
end;

procedure Init; begin
  ProcAppeleeStop := PrepareFin;

  GetDir (0,SauveRep);
  if SauveRep[length(SauveRep)]<>'\' then SauveRep := SauveRep+'\';

  { Cherche une installation stoppe. Trouv ? Si oui la continue, }
  { sinon cherche le script d'installation                         }
  if FichierExistant (NomFichCRH) then begin
    Crash := TRUE;
    ChargeEtatCrash;
  end else LitScriptInstall;

  { Affiche les informations sur l'installation }
  AfficheInfoInstall;

  { Traite les rpertoires (rentre dedans, existent-il, ...) }
  TraiteRepertoire;

  { Cherche une sauvegarde d'installation choue dans le rpertoire         }
  { destination                                                              }
  Crash := FALSE;
  Ecrit ('Cherche une sauvegarde d''installation choue ... ');
  if FichierExistant (NomFichCRH) then begin
    Crash := TRUE;
    EcriTcr ('trouve !',14);
    ChargeEtatCrash;
  end else EcriTcr ('aucune',10);
  EcriTr ('');
end;

begin
  { Initialisation : lecture du script d'installation, prparation, ... }
  Init;

  { Prpare la copie des fichiers }
  PrepareCopie;

  { Copie et reconstitue le fichier }
  EffectueCopie;

  { Le fichier a t reconstruit sans erreur ? }
  TestFichierFinal;

  { Procdure de fin }
  Fin;
end.